<?php
//    LaNewsFactory - web news engine written in PHP
//    Copyright (C) 2000-2003 Christophe Brocas - christophe.brocas@free.fr
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

// Check if the user has the correct password for the level requested
//

// styleofexit is a variable to set the behavior of the function :
// . if set to "exit", the function will end with the login script 
// . if set to "return", the function returns 1 or 0 to the calling function
function CheckHabilitation($level,$topicn,$styleofexit="exit")
{
  global $way, $Admin, $Moderator, $Reader, $Poster, $LNF_file_extension;
  
  if ($way==0) // Forum attitude 
  {
     if ($topicn!="AllTopics")
        $topicname = "news/" . $topicn;
     else
        $topicname = "news";
  }
  else         // News system attitude
     $topicname = "news";
 
  $ok=0;

  switch ($level)
  {
   case "Admin":
         if ($Admin == ReadPassword())
            $ok=1;
		 break;

   case "Moderator":
         if (($Admin == ReadPassword()) || ($Moderator == ReadPassword("$topicname-modpass".$LNF_file_extension)))
            $ok=1;
		 break;

   case "Poster":
         if (($Admin == ReadPassword()) || ($Moderator == ReadPassword("$topicname-modpass".$LNF_file_extension)) || ($Poster == ReadPassword("$topicname-posterpass".$LNF_file_extension)))
            $ok=1;
		 break;

   case "Reader":
         if (   ($Admin == ReadPassword()) || ($Moderator == ReadPassword("$topicname-modpass".$LNF_file_extension)) || ($Reader == ReadPassword ("$topicname-readerpass".$LNF_file_extension)) || ($Poster == ReadPassword("$topicname-posterpass".$LNF_file_extension)))
            $ok=1;
		 break;
  }

  if ($ok==0) 
  {
     if ($styleofexit=="exit")
     {
        setcookie("Admin","",time()+3600);
        setcookie("Moderator","",time()+3600);
        setcookie("Reader","",time()+3600);
        setcookie("Poster","",time()+3600);
        header("Location: " . $url . "login".$LNF_file_extension);
     }
     else
        return $ok;
	 exit;
  }
  else
     if ($styleofexit=="return")
        return $ok;
}

// Returns the encrypted password
//
function ReadPassword($path="pass.phpx")
{
  global $LNF_file_extension;
 
  // if the filepath is not supplied, set it with a filename
  //   which has the correct extension 
  if ($path == "pass.phpx")
     $path = "pass".$LNF_file_extension;

  include $path;
  return $mypass; 
}


// Store the encrypted password
//
function StorePassword($password, $path="pass.phpx")
{
  global $LNF_file_extension;
 
  // if the filepath is not supplied, set it with a filename
  //   which has the correct extension 
  if ($path == "pass.phpx")
     $path = "pass".$LNF_file_extension;
 
  $fic = fopen($path,"w");

  fputs($fic,"<"."?php ");
  fputs($fic,"\$mypass=\"$password\";");
  fputs($fic,"?".">");

  fclose($fic);
}

// Returns a crypted string from a clear password
//
function MyCrypt($password)
{
  return crypt($password,"LaNewsFactory");
}

?>