<?php
//    LaNewsFactory - web news engine written in PHP
//    Copyright (C) 2000-2003 Christophe Brocas - christophe.brocas@free.fr
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

// Displays the news and its answers.
//
function DisplayXMLArticle($path,$ans="notset")
{
global $lang, $display, $colour, $EnableHtml, $answersdepth, $LNF_template, $LNF_file_extension;;

$tplArt = new FastTemplate("templates/$LNF_template"); 
$tplArt->define( array( table      => "table.tpl", 
                        row        => "row.tpl", 
                        link       => "link.tpl", 
                        newstitle  => "newstitle.tpl", 
                        bottomnews => "bottomnews.tpl", 
                        line       => "line.tpl", 
                        comment    => "comment.tpl",
                        image      => "image.tpl",
                        colour0    => "colour0.tpl",
                        colour1    => "colour1.tpl",
                        colour2    => "colour2.tpl",
                        datetime   => "datetime.tpl",
                        td         => "td.tpl") ); 

// Check if some links are present in the news file
$fd=fopen("$path","r");
$contents = fread( $fd, 100000);
fclose( $fd );

$link_exists_in_news=strpos($contents, "<linksection>");

if (!is_integer($link_exists_in_news)) 
   $link_exists_in_news=FALSE;
else
   $link_exists_in_news=TRUE;
// end of check
   
$f=fopen("$path","r");

$index=1;
$nblignes=0;
$newsnotdisplayed=0;
$inanswer = 0;
$exit=0;
$light="";

$inscope=1;
$depth = $answersdepth;
$start=0;

$fname = basename($path);
$topname = GetTopic($fname);

$ligne = fgets($f,16000);

while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   $tab = explode(">",$ligne);
   switch ($tab[0])
   {
     // skip the lines that do not contain informations that have to be displayed
     case "<?<?xml version='1.0' standalone='yes' ?":
     case "<?xml version='1.0' standalone='yes' ?":
     case "<!-- version='3' --" :
     case "<!-- LNF_message_version='3' --":
     case "<!-- LNF_message_version='3.1' --":
     case "<news":
     case "<reply":
     case "<linkitem":
     case "</linkitem":
     case "</reply":
       break;

     case "<title":
       $inanswer = 0;
       $lineextract = explode("</",$tab[1]);
       $tplArt->assign(LNF_NEWS_TITLE,stripslashes($lineextract[0]));
       break;

     
     case "<email":
     case "<replyemail":
           if (($newsnotdisplayed==0) && ($inscope==1))
	   {
             //no spam feature : @ becomes _at_ .
	     $tab[1] = ereg_replace("@","_at_",$tab[1]);
             $lineextract = explode("</",$tab[1]);
             $tplArt->assign(LNF_LINK,"mailto:".$lineextract[0]);
           }
	   break;

     case "<author":
     case "<replyauthor":
	   if (($newsnotdisplayed==0) && ($inscope==1)) 
	   {
          $lineextract = explode("</",$tab[1]);
		  $tplArt->assign(LNF_DISPLAY,stripslashes($lineextract[0]));
          $templine="";
          for ($k=$start;$k < $numberoftabs; $k++) 
              $templine = $templine . "<blockquote>\n"; 
		  $tplArt->assign(LNF_LINE_BODY,$templine . "<img src=\"images/comment.gif\">\n"); 
          $tplArt->parse(LNF_MAILTO,"line");
          //erase previous content of LINE_BODY
          $tplArt->assign(LNF_LINE_BODY,"");
          $tplArt->parse(LNF_MAILTO,".link");
	   }
       break;

     case "<date":
     case "<replydate":
	   if (($newsnotdisplayed==0) && ($inscope==1)) 
	   {
          $lineextract = explode("</",$tab[1]);
		  $tplArt->assign(LNF_MAIL_DATE,$lineextract[0]);

          if ($inanswer==0) 
          {
             $tplArt->assign(LNF_LINK,"listdir".$LNF_file_extension."?top=$topname");
             $tplArt->assign(LNF_DISPLAY,"[".$topname."]");
             $tplArt->parse(LNF_LINK_TOPIC,"link");
       	     $tplArt->assign(LNF_TOPIC_LINK,"mailtoform".$LNF_file_extension."?newsfilename=". $path);
		     $tplArt->assign(LNF_IMAGE_FILE,$url."images/email.gif");
  		     $tplArt->assign(LNF_IMAGE_ALIGN,"none");
 		     $tplArt->assign(LNF_TOPIC_NAME,$display[$lang]["mailtoafriend"]);
   		     $tplArt->parse(LNF_NEWS_ICONS,"image");
			 $tplArt->parse(LNF_DATE_TIME,"datetime");

          }
          else
	      {
             $templine="";
             for ($k=0;$k < $numberoftabs; $k++) 
                 $templine = $templine . "</blockquote>\n"; 
             $tplArt->assign(LNF_LINK,"answer".$LNF_file_extension."?art=$path&ans=$lastBOAN&level=$levelBOAN");
             $tplArt->assign(LNF_DISPLAY,$display[$lang]["toanswer"]);
             $tplArt->parse(LNF_LINK_TOPIC,"link");
             $tplArt->parse(LNF_TD_CONTENT,".datetime");
             $tplArt->assign(LNF_LINE_BODY,$templine); 
             $tplArt->parse(LNF_TD_CONTENT,".line");
          }
	   }
       break;

     case "<body":
       $tplArt->assign(LNF_TD_WIDTH,"100%");
       $tplArt->parse(LNF_TD_CONTENT,"newstitle");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->parse(LNF_TABLE_ROWS,".row");
   
       $light="";
       // Erase previous content of TD_CONTENT
       $tplArt->assign(LNF_COMMENT_TEXT,"");
       $tplArt->parse(LNF_TD_CONTENT,"comment");
       $tplArt->assign(LNF_TD_WIDTH,"100%");

       if ($index==0)
          $index = 1;
       else
          $index = 0;

       break;

     case "<replybody":
       if (($newsnotdisplayed==0) && ($inscope==1))
	   {
          $light = $light . "  <blockquote>\n";
          $nblignes=0;
	   }
       break;

	 case "<linksection":
	   $light = $light . "<ul>";
	   break;

	 case "<link":
       $lineextract = explode("</",$tab[1]);
	   $light = $light . "<li><a href=\"".$lineextract[0]."\">";
       break;

     case "<linktext":
       $lineextract = explode("</",$tab[1]);
	   $light = $light . $lineextract[0]."</a></li>";
	   break;
     
	 case "</linksection":
	   $light = $light . "</ul>";
	   $tplArt->assign(LNF_LINE_BODY,$light); 
	   $tplArt->parse(LNF_TD_CONTENT,".line");
	   $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
	   $tplArt->parse(LNF_ROW,"td");
	   $tplArt->parse(LNF_TABLE_ROWS,".row");
	   $tplArt->assign(LNF_TABLE_WIDTH,"95%");
	   $tplArt->parse(FINAL,"table");

	   $tplArt->FastPrint(FINAL);

	   $light="";
	   $tplArt->assign(LNF_COMMENT_TEXT,"");
	   $tplArt->parse(LNF_TD_CONTENT,"comment");
	   $tplArt->parse(LNF_ROW,"comment");
	   $tplArt->parse(LNF_TABLE_ROWS,"comment");
	   break;

	 case "</body":
       if ($ans!="notset") 
          $inscope=0;
		  
       if ($link_exists_in_news==FALSE)
	   {
		   $tplArt->assign(LNF_LINE_BODY,$light); 
		   $tplArt->parse(LNF_TD_CONTENT,".line");
		   $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
		   $tplArt->parse(LNF_ROW,"td");
		   $tplArt->parse(LNF_TABLE_ROWS,".row");
		   $tplArt->assign(LNF_TABLE_WIDTH,"95%");
		   $tplArt->parse(FINAL,"table");

		   $tplArt->FastPrint(FINAL);

		   $light="";
		   $tplArt->assign(LNF_COMMENT_TEXT,"");
		   $tplArt->parse(LNF_TD_CONTENT,"comment");
		   $tplArt->parse(LNF_ROW,"comment");
		   $tplArt->parse(LNF_TABLE_ROWS,"comment");
       }
	   else 
	       $light=$light."<BR>";	   

	   if ($index==0)
          $index = 1;
       else
          $index = 0;
	   
       $inanswer = 1;

       break;

     case "</replybody":
	   if (($newsnotdisplayed==0) && ($inscope==1))
	   {        
          $light = $light . "<br>\n</blockquote>\n";

          if ($ans=="notset") 
          {
             for ($k=0;$k < $numberoftabs; $k++) 
                 $light = $light . "</blockquote>\n"; 
          }
          else
             for ($k=$start;$k<=$numberoftabs-$start;$k++) 
                 $light = $light . "</blockquote>\n"; 
                   
          if ($index==0)
             $index = 1;
          else
             $index = 0;

          $tplArt->assign(LNF_LINE_BODY,$light);
          $tplArt->parse(LNF_TD_CONTENT,".line");
          $tplArt->parse(LNF_ROW,"td");
          $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
          $tplArt->parse(LNF_TABLE_ROWS,".row");

          $tplArt->assign(LNF_COMMENT_TEXT,"");
          $tplArt->parse(LNF_TD_CONTENT,"comment");
          $tplArt->assign(LNF_LINE_BODY,"");
          $light = "";
	   }
       break;

     case "<replyid":
       $lineextract  = explode("</",$tab[1]);
	   $lineextract2 = explode("#",$lineextract[0]);
	   if ($inscope==0) 
	   {
	      if ($lineextract2[0]==$ans) 
		  {
		     $inscope=1;
			 $depth=$lineextract2[1] + $answersdepth;
			 $start=$lineextract2[1];
	 
			 $lastBOAN=$lineextract2[0];
			 $levelBOAN=$lineextract2[1]+1;
		               
			 if ($index==0)
				$index = 1;
			 else
				$index = 0;
		  }
	   }
	   else
	   {
	   if (($lineextract2[1]<=$start) && ($ans!="notset"))
	   {
          $exit=1;
	   }
	   elseif ($depth > $lineextract2[1]) 
	   {
		 if ($newsnotdisplayed!=0) 
         {
            for ($k=0;$k < $depth; $k++) 
                $light = $light . "<blockquote>\n"; 

            $tplArt->assign(LNF_LINE_BODY,$light);
            $tplArt->parse(LNF_TD_CONTENT,".line");
            $light="";

            $tplArt->assign(LNF_LINK,"print".$LNF_file_extension."?art=$path&ans=$lastBOAN");
            $tplArt->assign(LNF_DISPLAY,$newsnotdisplayed . " " . $display[$lang]["answer"] . "(s) ...");
            $tplArt->parse(LNF_TD_CONTENT,".link");

            $light = $light . "<br>\n"; 

            for ($k=0;$k < $depth; $k++) 
                $light = $light . "</blockquote>\n"; 

			if ($index==0)
               $index = 1;
            else
               $index = 0;

            $tplArt->assign(LNF_LINE_BODY,$light); 
            $tplArt->parse(LNF_TD_CONTENT,".line");
            $tplArt->parse(LNF_ROW,"td");
            $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
            $tplArt->parse(LNF_TABLE_ROWS,".row");
			
			$newsnotdisplayed=0;
            $tplArt->assign(LNF_COMMENT_TEXT,"");
            $tplArt->parse(LNF_TD_CONTENT,"comment");
            $tplArt->assign(LNF_LINE_BODY,"");
            $light = "";
         }
        
         $lastBOAN=$lineextract2[0];
	     $levelBOAN=$lineextract2[1]+1;
       
         $numberoftabs=$lineextract2[1];
	     if ($ans=="notset") 
	     {
	       for ($k=0;$k < $numberoftabs; $k++) 
               $light = $light . "<blockquote>\n"; 
	     }
		 else
		   for ($k=$start;$k<$numberoftabs;$k++) 
			   $light = $light . "<blockquote>\n"; 

       }
	   else
         $newsnotdisplayed++;
	   }
       break;

     default:
	   if ($EnableHtml==yes) 
	   {
	      // display HTML tags
		  $ligne=reverse_htmlspecialchars($ligne);
	   }
	   if (($newsnotdisplayed==0) && ($inscope==1)) 
	   {
          $nblignes = $nblignes + 1;

		  // display of the news/answers first line
          if ($nblignes == 1) 
		  {
             // first line of the news : display the image topic 
			 if ($inanswer==0)
			 {
				 $tplArt->assign(LNF_TOPIC_LINK,"listdir".$LNF_file_extension."?top=$topname");
				 $tplArt->assign(LNF_IMAGE_FILE,$url."images/topicimages/".GetTopicImage($topname));
				 $tplArt->assign(LNF_IMAGE_ALIGN,"right");
				 $tplArt->assign(LNF_TOPIC_NAME,$topname);
				 $tplArt->parse(LNF_TD_CONTENT,".image");
			 }
			 $light = $light . "  " . stripslashes($ligne) . "\n"; 
          }
		  else
		     // display of the news/answers lines after the 1st one
             $light = $light . "  <br>". stripslashes($ligne) . "\n"; 
       }
	   break;

   }
   $ligne = fgets($f,16000); 
   if ($exit==1) 
      break;
}

// In case of always deeper answers -> it would never displays the "N news not displayed" link.
if ($newsnotdisplayed!=0) 
{
    for ($k=0;$k < $depth; $k++) 
        $light = $light . "<blockquote>\n"; 

    $tplArt->assign(LNF_LINE_BODY,$light);
    $tplArt->parse(LNF_TD_CONTENT,".line");
    $light="";

    $tplArt->assign(LNF_LINK,"print".$LNF_file_extension."?art=$path&ans=$lastBOAN");
    $tplArt->assign(LNF_DISPLAY,$newsnotdisplayed . " " . $display[$lang]["answer"] . "(s) ...");
    $tplArt->parse(LNF_TD_CONTENT,".link");

    $light = $light . "<br>\n"; 

    for ($k=0;$k < $depth; $k++) 
        $light = $light . "</blockquote>\n"; 

    if ($index==0)
       $index = 1;
    else
       $index = 0;

    $tplArt->assign(LNF_LINE_BODY,$light); 
    $tplArt->parse(LNF_TD_CONTENT,".line");
    $tplArt->parse(LNF_ROW,"td");
    $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
    $tplArt->parse(LNF_TABLE_ROWS,".row");

    $newsnotdisplayed=0;
    $tplArt->assign(LNF_COMMENT_TEXT,"");
    $tplArt->parse(LNF_TD_CONTENT,"comment");
    $tplArt->assign(LNF_LINE_BODY,"");
    $light = "";
}

$tplArt->assign(LNF_TABLE_WIDTH,"95%");
$tplArt->parse(FINAL,"table");
$tplArt->FastPrint(FINAL);
fclose($f);
}

// Returns an array with all the files that exist in the directory pathname
//  and whose name include the pattern 
//
Function DisplayLang()
{
  global $lang, $LNF_file_extension ;

  $tab = ListDirInArray("".$LNF_file_extension,"./lang");
  $taille = sizeof($tab);
 
  $rlang = "<select name=\"newlang\" size=1>\n";

  for($i=0;$i<$taille;$i++)
  {   
    $tab1 = explode("-",$tab[$i]);
    $tab2 = explode(".",$tab1[1]);

    if ($lang==$tab2[0])
       $rlang = $rlang . "<option selected value=$tab2[0] > $tab2[0] </option>";
    else
       $rlang = $rlang . "<option value=$tab2[0]>  $tab2[0] </option>";
  }
 
  $rlang = $rlang . "</select>\n";
  
  return $rlang;
}

// Displays only the news without answers but it displays also
//  the answers numbers and the last date/time update.
//  - That function should be a part of DisplayXMLArticle(), I know. 
//    Bad code, will be cleaned in the future ... maybe ;-)
//
function DisplayJustXMLArticle($path)
{

global $way, $lang, $display, $colour, $linespernews, $EnableHtml, $LNF_template, $LNF_file_extension;

$tplArt = new FastTemplate("templates/$LNF_template"); 
$tplArt->define( array( table      => "table.tpl", 
                        row        => "row.tpl", 
                        link       => "link.tpl", 
                        newstitle  => "newstitle.tpl", 
                        bottomnews => "bottomnews.tpl", 
                        noanswer   => "noanswerbottomnews.tpl",
                        datetime   => "datetime.tpl",
                        line       => "line.tpl", 
                        image      => "image.tpl", 
                        comment    => "comment.tpl",
                        colour0    => "colour0.tpl",
                        colour1    => "colour1.tpl",
                        colour2    => "colour2.tpl",
                        td         => "td.tpl") ); 

// set the maximum number of char of the news to display.
$display_limit=600;

// read in one line all the news file
$fd=fopen("$path","r");
$contents = fread( $fd, 100000);
fclose( $fd );

// Check if some links are present in the news file
$link_exists_in_news=strpos($contents, "<linksection>");

if (!is_integer($link_exists_in_news)) 
   $link_exists_in_news=FALSE;
else
   $link_exists_in_news=TRUE;
// end of check
$contents=strtolower($contents);
// check at what position starts/ends the body of the news file
$display_start=strpos($contents, "<body>");
$display_start=$display_start+7;
$display_end=strpos($contents, "</body>");

// checks the number of HTML begin/end link tags (ie "<a " or </a>)are present in the 
//  news extract I want to display
$display_line=substr($contents,$display_start,$display_limit);
$display_deb=sizeof(explode("&lt;a ",$display_line))-1;
$display_fin=sizeof(explode("&lt;/a&gt;",$display_line))-1;

// If the number of HTML begin/end link tags are not equal, I modify the max number 
//  of chars to display the next HTML begin/end link tags
if ($display_deb!=$display_fin)
{
   $display_nextend = strpos($contents, "&lt;/a&gt;", $display_start + $display_limit);
   $display_limit = $display_nextend - $display_start+10;
}


$f=fopen("$path","r");

$nbcar=0;
$nblignes=0;
$index=0;
$lastanswer="";
$lastname="";
$answers=0;
$exit=0;
$light="";

$fname = basename($path);
$topname = GetTopic($fname);

$ligne = fgets($f,16000);


while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   

   $tab = explode(">",$ligne);
   switch ($tab[0])
   {
     case "<?<?xml version='1.0' standalone='yes' ?":
   	 case "<?xml version='1.0' standalone='yes' ?":
     case "<!-- version='3' --" :
     case "<!-- LNF_message_version='3' --":
     case "<!-- LNF_message_version='3.1' --":
     case "<news":
   	 case "<reply":
   	 case "<linkitem":
   	 case "</linkitem":
   	 case "</reply":
       break;

     case "<title":
       $lineextract = explode("</",$tab[1]);
       $tplArt->assign(LNF_NEWS_TITLE,stripslashes($lineextract[0]));

       break;

     case "<email":
       $tab[1] = ereg_replace("@","_at_",$tab[1]);
       $lineextract = explode("</",$tab[1]);
       $tplArt->assign(LNF_LINK,"mailto:".$lineextract[0]);

       break;

     case "<author":
       $lineextract = explode("</",$tab[1]);
       $tplArt->assign(LNF_DISPLAY,stripslashes($lineextract[0]));
       $tplArt->parse(LNF_MAILTO,"link");
       break;

     case "<date":
       $lineextract = explode("</",$tab[1]);
       $tplArt->assign(LNF_MAIL_DATE,$lineextract[0]);
       $tplArt->assign(LNF_LINK,"listdir".$LNF_file_extension."?top=$topname");
       $tplArt->assign(LNF_DISPLAY,"[".$topname."]");
       $tplArt->parse(LNF_LINK_TOPIC,"link");
       
	   $tplArt->assign(LNF_TOPIC_LINK,"mailtoform".$LNF_file_extension."?newsfilename=". $path);
	   $tplArt->assign(LNF_IMAGE_FILE,$url."images/email.gif");
	   $tplArt->assign(LNF_IMAGE_ALIGN,"none");
	   $tplArt->assign(LNF_TOPIC_NAME,$display[$lang]["mailtoafriend"]);
       $tplArt->parse(LNF_NEWS_ICONS,"image");
	  
       $tplArt->parse(LNF_DATE_TIME,"datetime");

       break;

     case "<body":
       $tplArt->assign(LNF_TD_WIDTH,"100%");
       $tplArt->parse(LNF_TD_CONTENT,"newstitle");
       $tplArt->assign(LNF_BACKGROUND_COLOR,$colour[$index]); 
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->parse(LNF_TABLE_ROWS,".row");
   
       $light="";
       // Erase previous content of TD_CONTENT
       $tplArt->assign(LNF_COMMENT_TEXT,"");
       $tplArt->parse(LNF_TD_CONTENT,"comment");
       $tplArt->assign(LNF_TD_WIDTH,"100%");

       if ($index==0)
          $index = 1;
       else
          $index = 0;

       break;
     
	 case "<linksection":
	   $light = $light . "<ul>";
	   break;

	 case "<link":
       $lineextract = explode("</",$tab[1]);
	   $light = $light . "<li><a href=\"".$lineextract[0]."\">";
       break;

     case "<linktext":
       $lineextract = explode("</",$tab[1]);
	   $light = $light . $lineextract[0]."</a></li>";
	   break;
     
	 case "</linksection":
	   $light = $light . "</ul>";
       $exit = 1;
	   $tplArt->assign(LNF_LINE_BODY,$light);
       $tplArt->parse(LNF_TD_CONTENT,".line");
       $light="";
	   break;

	 case "</body":
       $EndOfNewsBody = 1;
       if ($link_exists_in_news==FALSE)
	   {
		   $exit = 1;
		   $tplArt->assign(LNF_LINE_BODY,$light . " <br>");
		   $tplArt->parse(LNF_TD_CONTENT,".line");
		   $light="";
       }
	   else
		   $light = $light . "<br>";
       break;

     default:
	   $nblignes = $nblignes + 1;
      
	   if ($EnableHtml==yes) 
	   {
		  $ligne=reverse_htmlspecialchars($ligne);
	   }

       if (($nbcar + strlen($ligne)) > $display_limit)
       {
		  // add the image inclusion (in case of a news system site of course)
		  // when the news begin with a line that exceed the number of char limit 
		  // before the first \n
		  if (($nblignes == 1)and ($way == 1))
		  {
		     $tplArt->assign(LNF_TOPIC_LINK,"listdir".$LNF_file_extension."?top=$topname");
             $tplArt->assign(LNF_IMAGE_FILE,$url."images/topicimages/".GetTopicImage($topname));
             $tplArt->assign(LNF_IMAGE_ALIGN,"right");
             $tplArt->assign(LNF_TOPIC_NAME,$topname);
             $tplArt->parse(LNF_TD_CONTENT,".image");
		  }
	      
		  $lig = substr($ligne,0,$display_limit - $nbcar);
          $light = $light . "     " . stripslashes($lig) . " <br><b>[...]</b> <br>";
          
          $tplArt->assign(LNF_LINE_BODY,$light);
          $tplArt->parse(LNF_TD_CONTENT,".line");
          
          $exit = 1;
       }
       elseif ($nblignes > $linespernews)
       {
          $light = $light . "   <br><b>[...]</b> <br>";

          $tplArt->assign(LNF_LINE_BODY,$light);
          $tplArt->parse(LNF_TD_CONTENT,".line");
          
          $exit = 1;
       }
       else
       {
          $nbcar  = $nbcar + strlen($ligne);

		  if ($nblignes == 1)
		  {
			 // display images only in news system behavior not in forum behavior
			 if ($way == 1)
			 {
			    $tplArt->assign(LNF_TOPIC_LINK,"listdir".$LNF_file_extension."?top=$topname");
                $tplArt->assign(LNF_IMAGE_FILE,$url."images/topicimages/".GetTopicImage($topname));
                $tplArt->assign(LNF_IMAGE_ALIGN,"right");
                $tplArt->assign(LNF_TOPIC_NAME,$topname);
                $tplArt->parse(LNF_TD_CONTENT,".image");
	            $light = $light . stripslashes($ligne);
			 }
			 else 
	            $light = $light . stripslashes($ligne);
          }
		  else
          {
			 $light=  $light . "<br> ". stripslashes($ligne);
          }
       }
 
       break;
   }

   $ligne = fgets($f,16000); 
   if ($exit == 1)
      break;
}

$StoreName=0;
$newdate=0;
$newhour=0;

while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   $tab = explode(">",$ligne);
   switch ($tab[0])
   {
     case "<replyauthor":
       if ($StoreName==1) 
       {    
		  $tab2 = explode("</",$tab[1]);
          $lastname = stripslashes($tab2[0]);
       }

	   break;
     
	 case "<replydate":
       if ($StoreName==1) 
       {
		  $tab2 = explode("</",$tab[1]);
	      $lastanswer = $tab2[0];
		  $StoreName=0;
       }
	   break;

     case "<replyid":
       $answers++;
	   // extract the date and time of the reply
	   // if it is a newer date than the previous stored
	   // then store the date to display it at the bottom of the news of the main page.
       $lineextract = explode("#",$tab[1]);
	   $tab2=explode("-",$lineextract[0]);
	   $datetab=(int)$tab2[1];
	   $hourtab=(int)$tab2[2];
	   if ($datetab>$newdate) 
	   {
	      $newdate=$datetab;
          $StoreName=1;
          $newhour=$hourtab;
	   }
	   elseif ($datetab==$newdate) 
	   {
	      $newdate=$datetab;
	      if ($hourtab>=$newhour) 
	      {
		    $StoreName=1;
            $newhour=$hourtab;
	      }  
	   }

       break;

     default:
       break;
   }

   $ligne = fgets($f,16000); 
}

if ($answers > 0)
{
   $tplArt->assign(LNF_LINK,"print".$LNF_file_extension."?art=$path");
   if ($EndOfNewsBody != 1)
      $tplArt->assign(LNF_DISPLAY,$display[$lang]["continue"].">>");
   else
      $tplArt->assign(LNF_DISPLAY,$display[$lang]["toanswer"]);
   $tplArt->parse(LNF_RANDA,"link"); 

   $tplArt->assign(LNF_NUMBER_ANSWERS,$answers);
   $tplArt->assign(LNF_ANSWERS,$display[$lang]["answer"]);
   $tplArt->assign(LNF_UPDATED,$display[$lang]["updated"]);
   $tplArt->assign(LNF_LAST_DATE,$lastanswer);
   $tplArt->assign(LNF_LAST_AUTHOR,$lastname);

   $tplArt->parse(LNF_TD_CONTENT,".bottomnews");

}
else
{
   $tplArt->assign(LNF_LINK,"print".$LNF_file_extension."?art=$path");
   if ($EndOfNewsBody != 1)
      $tplArt->assign(LNF_DISPLAY,$display[$lang]["continue"] . " (0 " . $display[$lang]["answer"] . ") >>");
   else
      $tplArt->assign(LNF_DISPLAY,$display[$lang]["answer"] . " (0 " . $display[$lang]["answer"] . ") >>");
   $tplArt->parse(LNF_ANSWER_NEWS,"link");
   $tplArt->parse(LNF_TD_CONTENT,".noanswer");
}
fclose($f);

$tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
$tplArt->parse(LNF_ROW,"td");
$tplArt->parse(LNF_TABLE_ROWS,".row");

$tplArt->assign(LNF_TABLE_WIDTH,"95%");
$tplArt->parse(FINAL,"table");
$tplArt->FastPrint(FINAL);
}

// Display an article for edit purposes
//
function EditXMLArticle($path,$linkto="moderatenews.phpx")
{

global $lang, $display, $colour, $EnableHtml, $LNF_template,$LNF_file_extension;

// Check if some links are present in the news file
$fd=fopen("$path","r");
$contents = fread( $fd, 100000);
fclose( $fd );

$link_exists_in_news=strpos($contents, "<linksection>");

if (!is_integer($link_exists_in_news)) 
   $link_exists_in_news=FALSE;
else
   $link_exists_in_news=TRUE;
// end of check

$f=fopen("$path","r");

$index=1;
$nblignes=0;

// if the linkto aeg is not supplied, set it with a filename
//   which has the correct extension 
if ($linkto == "moderatenews.phpx")
   $linkto = "moderatenews".$LNF_file_extension;

// HTML Table only there to make a dark border

print "     <form action=\"$linkto\" method=\"post\">";
print "        <input type=\"hidden\" name=\"art\"    value=\"" . $path . "\">";
$newt=GetTopic($path);
print "        <input type=\"hidden\" name=\"newtopic\" value=\"$newt\">";
print "        <input type=\"hidden\" name=\"modify\" value=\"1\">";

$tplArt = new FastTemplate("templates/$LNF_template"); 
$tplArt->define( array( table      => "table.tpl", 
                      row        => "row.tpl", 
                      line       => "line.tpl", 
                      colour0    => "colour0.tpl",
                      colour1    => "colour1.tpl",
                      colour2    => "colour2.tpl",
                      td         => "td.tpl") ); 

$ligne = fgets($f,16000);
$exit=0;

$tplArt->assign(LNF_TD_WIDTH,"25%");
if ($linkto=="moderatenews".$LNF_file_extension) 
   $tplArt->assign(LNF_TD_CONTENT,"<b>".$display[$lang]["moderation"]."</b>");
else
   $tplArt->assign(LNF_TD_CONTENT,"<b>".$display[$lang]["modify"]."</b>");
$tplArt->parse(LNF_ROW,"td");
$tplArt->assign(LNF_TD_WIDTH,"75%");
$tplArt->assign(LNF_TD_CONTENT,"&nbsp;");
$tplArt->parse(LNF_ROW,".td");
$tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
$tplArt->parse(LNF_TABLE_ROWS,"row");

if ($linkto=="moderatenews".$LNF_file_extension) 
{
    // --- changing topic during moderation only
    $topname=GetTopic($path);

    $tab = ListDirInArray(".top","news");
    $taille = sizeof($tab);

    $rtopic = "<select name=\"newtopic\" size=1>\n";

    for($i=0;$i<$taille;$i++)
    {   
    $tab1 = explode(".top",$tab[$i]);

    if ($topname==$tab1[0])
       $rtopic = $rtopic . "<option selected value=$tab1[0] > $tab1[0] </option>";
    else
       $rtopic = $rtopic . "<option value=$tab1[0]>  $tab1[0] </option>";
    }

    $rtopic = $rtopic . "</select>\n";

    $tplArt->assign(LNF_TD_WIDTH,"25%");
    $tplArt->assign(LNF_TD_CONTENT,$display[$lang]["topic"]);
    $tplArt->parse(LNF_ROW,"td");
    $tplArt->assign(LNF_TD_WIDTH,"75%");
    $tplArt->assign(LNF_TD_CONTENT,$rtopic);
    $tplArt->parse(LNF_ROW,".td");
    $tplArt->parse(LNF_BACKGROUND_COLOR,"colour0");
    $tplArt->parse(LNF_TABLE_ROWS,".row");
}

$link_number=1;
$linktext_number=1;

while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   $tab = explode(">",$ligne);
   switch ($tab[0])
   {
   case "<?<?xml version='1.0' standalone='yes' ?" :
   case "<?xml version='1.0' standalone='yes' ?":
   case "<!-- version='3' --" :
   case "<!-- LNF_message_version='3' --":
   case "<!-- LNF_message_version='3.1' --":
   case "<linkitem":
   case "</linkitem":
   case "<news" :
       break;

   case "<title":
       $lineextract = explode("</",$tab[1]);
       $tplArt->assign(LNF_TD_WIDTH,"25%");
       $tplArt->assign(LNF_TD_CONTENT,$display[$lang]["title"]);
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->assign(LNF_TD_WIDTH,"75%");
       $tplArt->assign(LNF_TD_CONTENT,"<input type=\"text\" name=\"titre\" value=\"" .  stripslashes($lineextract[0]) . "\" size=\"60\" maxlength=\"60\">");
       $tplArt->parse(LNF_ROW,".td");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour0");
       $tplArt->parse(LNF_TABLE_ROWS,".row");


       if ($index==0)
          $index = 1;
       else
          $index = 0;

       break;

   case "<body":
       $line= "<textarea name=\"corps\" rows=20 cols=60 wrap=PHYSICAL>";
       break;

   case "</body":
       $line=$line."</textarea></center>";
       $tplArt->assign(LNF_TD_WIDTH,"25%");
       $tplArt->assign(LNF_TD_CONTENT,"&nbsp;");
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->assign(LNF_TD_WIDTH,"75%");
       $tplArt->assign(LNF_TD_CONTENT,$line);
       $tplArt->parse(LNF_ROW,".td");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour0");
       $tplArt->parse(LNF_TABLE_ROWS,".row");

	   if ($link_exists_in_news==FALSE)
	   {
		   $tplArt->assign(LNF_TD_WIDTH,"25%");
		   $tplArt->assign(LNF_TD_CONTENT,"&nbsp;");
		   $tplArt->parse(LNF_ROW,"td");
		   $tplArt->assign(LNF_TD_WIDTH,"75%");
		   $tplArt->assign(LNF_TD_CONTENT,"<input type=\"submit\" value=\"" . $display[$lang]["modify"] . "\">");
		   $tplArt->parse(LNF_ROW,".td");
		   $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
		   $tplArt->parse(LNF_TABLE_ROWS,".row");

		   $nblignes=0;
		   $exit=1;
		   
		   $tplArt->assign(LNF_TABLE_WIDTH,"95%");
		   $tplArt->parse(FINAL,"table");

		  $tplArt->FastPrint(FINAL);
	   }
	   break;

   case "<linksection":
	   $linkitem = "\n<table>\n";
		
	   break;

   case "<link":
       $lineextract = explode("</",$tab[1]);
	   $linkitem=$linkitem."<tr>\n<td width=\"20%\">\n";
       $linkitem=$linkitem.$display[$lang]["link"];
	   $linkitem=$linkitem."</td>\n<td width=\"80%\">\n";
	   $linkitem=$linkitem."<input type=\"text\" value=\"".$lineextract[0]."\" name=\"link".$link_number."\" SIZE=\"60\" MAXLENGTH=\"60\">\n";
	   $link_number++;
	   $linkitem=$linkitem."</td>\n</tr>\n";

       break;

   case "<linktext":
       $lineextract = explode("</",$tab[1]);
	   $linkitem=$linkitem."<tr>\n<td width=\"20%\">";
	   $linkitem=$linkitem.$display[$lang]["description"];
	   $linkitem=$linkitem."</td>\n<td width=\"80%\">\n";
	   $linkitem=$linkitem."<input type=\"text\" value=\"".$lineextract[0]."\" name=\"linktext".$linktext_number."\" SIZE=\"60\" MAXLENGTH=\"60\">\n";
	   $linktext_number++;
	   $linkitem=$linkitem."</td>\n</tr>\n";
	   break;
     
   case "</linksection":
	   $linkitem=$linkitem."</table>\n";
       $tplArt->assign(LNF_TD_WIDTH,"25%");
       $tplArt->assign(LNF_TD_CONTENT,$display[$lang]["links"]);
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->assign(LNF_TD_WIDTH,"75%");
       $tplArt->assign(LNF_TD_CONTENT,$linkitem);
       $tplArt->parse(LNF_ROW,".td");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour0");
       $tplArt->parse(LNF_TABLE_ROWS,".row");
	   $tplArt->assign(LNF_TD_WIDTH,"25%");
	   $tplArt->assign(LNF_TD_CONTENT,"&nbsp;");
	   $tplArt->parse(LNF_ROW,"td");
	   $tplArt->assign(LNF_TD_WIDTH,"75%");
	   $tplArt->assign(LNF_TD_CONTENT,"<input type=\"submit\" value=\"" . $display[$lang]["modify"] . "\">");
	   $tplArt->parse(LNF_ROW,".td");
	   $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
	   $tplArt->parse(LNF_TABLE_ROWS,".row");

	   $nblignes=0;
	   $exit=1;
	   
	   $tplArt->assign(LNF_TABLE_WIDTH,"95%");
	   $tplArt->parse(FINAL,"table");

       $tplArt->FastPrint(FINAL);
 
	   break;

   case "<email":
       $lineextract = explode("</",$tab[1]);
       echo "<input type=\"hidden\" name=\"email\" value=\"" . stripslashes($lineextract[0]) . "\">";
       break;

   case "<author":
       $lineextract = explode("</",$tab[1]);
       $tplArt->assign(LNF_TD_WIDTH,"25%");
       $tplArt->assign(LNF_TD_CONTENT,$display[$lang]["name"]);
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->assign(LNF_TD_WIDTH,"75%");
       $tplArt->assign(LNF_TD_CONTENT,"<input  name=\"nom\" value=\"" . stripslashes($lineextract[0]) . "\">");
       $tplArt->parse(LNF_ROW,".td");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour0");
       $tplArt->parse(LNF_TABLE_ROWS,".row");

       break;

   case "<date":
       $lineextract = explode("</",$tab[1]);
       echo "<input type=\"hidden\" name=\"date\" value=\"" . $lineextract[0] . "\">";
       break;
       
   default:
	   if ($EnableHtml==yes) 
	   {
		 $ligne=reverse_htmlspecialchars($ligne);
	   }
       $nblignes = $nblignes + 1;
       if ($nblignes == 1)
           $line=$line . stripslashes($ligne);
       else
           $line=$line . stripslashes($ligne);
       break;

   }
   if ($exit == 1)
      break;

   $ligne = fgets($f,16000);
}

echo "</form>";

fclose($f);
}

// Return an article (title, writer, date) up to moderation in a tab
//
function DisplayXMLShortMod($path,$ind,$checkbox,$linkto="moderatenews.phpx")
{

global $lang, $display, $colour, $EnableHtml, $LNF_file_extension;

$f=fopen("$path","r");

if (($ind % 2) == 0)
   $index=0;
else
   $index=1;

$ligne = fgets($f,16000);

// if the linkto arg is not supplied, set it with a filename
//   which has the correct extension 
if ($linkto == "moderatenews.phpx")
   $linkto = "moderatenews".$LNF_file_extension;
   
while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   
   // I do not transform HTML into anothers terms because of XML news format
   /*if ($EnableHtml==0) 
   {
      $ligne=HtmlEntities($ligne);
   }*/

   $tab = explode(">",$ligne);
   switch ($tab[0])
   {
     case "<?<?xml version='1.0' standalone='yes' ?":
	 case "<?xml version='1.0' standalone='yes' ?":
     case "<!-- version='3' --" :
     case "<!-- LNF_message_version='3' --":
     case "<!-- LNF_message_version='3.1' --":
     case "<news":
       break;

     case "<title":
       $lineextract = explode("</",$tab[1]);
	   if ($checkbox==1) 
          $rtab[0] = "<input type=\"checkbox\" name=\"message[]\" value=\"" . $path . "\">";	   
       $rtab[0] = $rtab[0] . " <a href=\"$linkto?art=$path\"> <big>" . stripslashes($lineextract[0]) . "</big></a>\n";

       break;

     case "<author":
       $lineextract = explode("</",$tab[1]);
       $rtab[1] = stripslashes($lineextract[0]);
       break;

     case "<date":
       $lineextract = explode("</",$tab[1]);
       $rtab[2] = stripslashes($lineextract[0]);
       $exit = 1;
       break;

     case "</body":
       $exit = 1;
       break;

     default:
       break;

   }

   $ligne = fgets($f,16000); 
   if ($exit == 1)
      break;
}

fclose($f);
return $rtab;
}
?>
