<?php
// Displays the news and its answers.
//
function DisplayXMLArticle($path,$ans="notset")
{
global $lang, $display, $colour, $EnableHtml, $answersdepth, $LNF_template;

$tplArt = new FastTemplate("templates/$LNF_template"); 
$tplArt->define( array( table      => "table.tpl", 
                        row        => "row.tpl", 
                        link       => "link.tpl", 
                        newstitle  => "newstitle.tpl", 
                        bottomnews => "bottomnews.tpl", 
                        line       => "line.tpl", 
                        comment    => "comment.tpl",
                        image      => "image.tpl",
                        colour0    => "colour0.tpl",
                        colour1    => "colour1.tpl",
                        colour2    => "colour2.tpl",
                        datetime   => "datetime.tpl",
                        td         => "td.tpl") ); 

// Check if some links are present in the news file
$fd=fopen("$path","r");
$contents = fread( $fd, 100000);
fclose( $fd );

$link_exists_in_news=strpos($contents, "<linksection>");

if (!is_integer($link_exists_in_news)) 
   $link_exists_in_news=FALSE;
else
   $link_exists_in_news=TRUE;
// end of check
   
$f=fopen("$path","r");

$index=1;
$nblignes=0;
$newsnotdisplayed=0;
$inanswer = 0;
$exit=0;
$light="";

$inscope=1;
$depth = $answersdepth;
$start=0;

$fname = basename($path);
$topname = GetTopic($fname);

$ligne = fgets($f,16000);

while (!feof($f))
{
   $ligne = ereg_replace("\n","",$ligne);   
   $tab = explode(">",$ligne);
   switch ($tab[0])
   {
     // skip the lines that do not contain informations that have to be displayed
	 case "<?<?xml version='1.0' standalone='yes' ?":
	 case "<?xml version='1.0' standalone='yes' ?":
     case "<!-- LNF_message_version='3' --":
     case "<news":
	 case "<reply":
	 case "<linkitem":
	 case "</linkitem":
	 case "</reply":
       break;

	 case "<title":
       $inanswer = 0;
       $lineextract = explode("</",$tab[1]);
       $tplArt->assign(LNF_NEWS_TITLE,stripslashes($lineextract[0]));
       break;

     
	 case "<email":
	 case "<replyemail":
	   if (($newsnotdisplayed==0) && ($inscope==1))
	   {
          $tab[1] = ereg_replace("@","_at_",$tab[1]);
          $lineextract = explode("</",$tab[1]);
          $tplArt->assign(LNF_LINK,"mailto:".$lineextract[0]);
       }
	   break;

     case "<author":
     case "<replyauthor":
	   if (($newsnotdisplayed==0) && ($inscope==1)) 
	   {
          $lineextract = explode("</",$tab[1]);
		  $tplArt->assign(LNF_DISPLAY,$lineextract[0]);
          $templine="";
          for ($k=$start;$k < $numberoftabs; $k++) 
              $templine = $templine . "<blockquote>\n"; 
		  $tplArt->assign(LNF_LINE_BODY,$templine . "<img src=\"images/comment.gif\">\n"); 
          $tplArt->parse(LNF_MAILTO,"line");
          //erase previous content of LINE_BODY
          $tplArt->assign(LNF_LINE_BODY,"");
          $tplArt->parse(LNF_MAILTO,".link");
	   }
       break;

     case "<date":
     case "<replydate":
	   if (($newsnotdisplayed==0) && ($inscope==1)) 
	   {
          $lineextract = explode("</",$tab[1]);
		  $tplArt->assign(LNF_MAIL_DATE,$lineextract[0]);

          if ($inanswer==0) 
          {
             $tplArt->assign(LNF_LINK,"listdir".$LNF_file_extension."?top=$topname");
             $tplArt->assign(LNF_DISPLAY,"[".$topname."]");
             $tplArt->parse(LNF_LINK_TOPIC,"link");
       	     $tplArt->assign(LNF_TOPIC_LINK,"mailtoform".$LNF_file_extension."?newsfilename=". $path);
		     $tplArt->assign(LNF_IMAGE_FILE,$url."images/email.gif");
  		     $tplArt->assign(LNF_IMAGE_ALIGN,"none");
 		     $tplArt->assign(LNF_TOPIC_NAME,$display[$lang]["mailtoafriend"]);
   		     $tplArt->parse(LNF_NEWS_ICONS,"image");
			 $tplArt->parse(LNF_DATE_TIME,"datetime");

          }
          else
	      {
             $templine="";
             for ($k=0;$k < $numberoftabs; $k++) 
                 $templine = $templine . "</blockquote>\n"; 
             $tplArt->assign(LNF_LINK,"answer".$LNF_file_extension."?art=$path&ans=$lastBOAN&level=$levelBOAN");
             $tplArt->assign(LNF_DISPLAY,$display[$lang]["toanswer"]);
             $tplArt->parse(LNF_LINK_TOPIC,"link");
             $tplArt->parse(LNF_TD_CONTENT,".datetime");
             $tplArt->assign(LNF_LINE_BODY,$templine); 
             $tplArt->parse(LNF_TD_CONTENT,".line");
          }
	   }
       break;

     case "<body":
       $tplArt->assign(LNF_TD_WIDTH,"100%");
       $tplArt->parse(LNF_TD_CONTENT,"newstitle");
       $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
       $tplArt->parse(LNF_ROW,"td");
       $tplArt->parse(LNF_TABLE_ROWS,".row");
   
       $light="";
       // Erase previous content of TD_CONTENT
       $tplArt->assign(LNF_COMMENT_TEXT,"");
       $tplArt->parse(LNF_TD_CONTENT,"comment");
       $tplArt->assign(LNF_TD_WIDTH,"100%");

       if ($index==0)
          $index = 1;
       else
          $index = 0;

       break;

     case "<replybody":
       if (($newsnotdisplayed==0) && ($inscope==1))
	   {
          $light = $light . "  <blockquote>\n";
          $nblignes=0;
	   }
       break;

	 case "<linksection":
	   $light = $light . "<ul>";
	   break;

	 case "<link":
       $lineextract = explode("</",$tab[1]);
	   $light = $light . "<li><a href=\"".$lineextract[0]."\">";
       break;

     case "<linktext":
       $lineextract = explode("</",$tab[1]);
	   $light = $light . $lineextract[0]."</a></li>";
	   break;
     
	 case "</linksection":
	   $light = $light . "</ul>";
	   $tplArt->assign(LNF_LINE_BODY,$light); 
	   $tplArt->parse(LNF_TD_CONTENT,".line");
	   $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
	   $tplArt->parse(LNF_ROW,"td");
	   $tplArt->parse(LNF_TABLE_ROWS,".row");
	   $tplArt->assign(LNF_TABLE_WIDTH,"95%");
	   $tplArt->parse(FINAL,"table");

	   $tplArt->FastPrint(FINAL);

	   $light="";
	   $tplArt->assign(LNF_COMMENT_TEXT,"");
	   $tplArt->parse(LNF_TD_CONTENT,"comment");
	   $tplArt->parse(LNF_ROW,"comment");
	   $tplArt->parse(LNF_TABLE_ROWS,"comment");
	   break;

	 case "</body":
       if ($ans!="notset") 
          $inscope=0;
		  
       if ($link_exists_in_news==FALSE)
	   {
		   $tplArt->assign(LNF_LINE_BODY,$light); 
		   $tplArt->parse(LNF_TD_CONTENT,".line");
		   $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
		   $tplArt->parse(LNF_ROW,"td");
		   $tplArt->parse(LNF_TABLE_ROWS,".row");
		   $tplArt->assign(LNF_TABLE_WIDTH,"95%");
		   $tplArt->parse(FINAL,"table");

		   $tplArt->FastPrint(FINAL);

		   $light="";
		   $tplArt->assign(LNF_COMMENT_TEXT,"");
		   $tplArt->parse(LNF_TD_CONTENT,"comment");
		   $tplArt->parse(LNF_ROW,"comment");
		   $tplArt->parse(LNF_TABLE_ROWS,"comment");
       }
	   else 
	       $light=$light."<BR>";	   

	   if ($index==0)
          $index = 1;
       else
          $index = 0;
	   
       $inanswer = 1;

       break;

     case "</replybody":
	   if (($newsnotdisplayed==0) && ($inscope==1))
	   {        
          $light = $light . "<br>\n</blockquote>\n";

          if ($ans=="notset") 
          {
             for ($k=0;$k < $numberoftabs; $k++) 
                 $light = $light . "</blockquote>\n"; 
          }
          else
             for ($k=$start;$k<=$numberoftabs-$start;$k++) 
                 $light = $light . "</blockquote>\n"; 
                   
          if ($index==0)
             $index = 1;
          else
             $index = 0;

          $tplArt->assign(LNF_LINE_BODY,$light);
          $tplArt->parse(LNF_TD_CONTENT,".line");
          $tplArt->parse(LNF_ROW,"td");
          $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
          $tplArt->parse(LNF_TABLE_ROWS,".row");

          $tplArt->assign(LNF_COMMENT_TEXT,"");
          $tplArt->parse(LNF_TD_CONTENT,"comment");
          $tplArt->assign(LNF_LINE_BODY,"");
          $light = "";
	   }
       break;

     case "<replyid":
       $lineextract  = explode("</",$tab[1]);
	   $lineextract2 = explode("#",$lineextract[0]);
	   if ($inscope==0) 
	   {
	      if ($lineextract2[0]==$ans) 
		  {
		     $inscope=1;
			 $depth=$lineextract2[1] + $answersdepth;
			 $start=$lineextract2[1];
	 
			 $lastBOAN=$lineextract2[0];
			 $levelBOAN=$lineextract2[1]+1;
		               
			 if ($index==0)
				$index = 1;
			 else
				$index = 0;
		  }
	   }
	   else
	   {
	   if (($lineextract2[1]<=$start) && ($ans!="notset"))
	   {
          $exit=1;
	   }
	   elseif ($depth > $lineextract2[1]) 
	   {
		 if ($newsnotdisplayed!=0) 
         {
            for ($k=0;$k < $depth; $k++) 
                $light = $light . "<blockquote>\n"; 

            $tplArt->assign(LNF_LINE_BODY,$light);
            $tplArt->parse(LNF_TD_CONTENT,".line");
            $light="";

            $tplArt->assign(LNF_LINK,"print".$LNF_file_extension."?art=$path&ans=$lastBOAN");
            $tplArt->assign(LNF_DISPLAY,$newsnotdisplayed . " " . $display[$lang]["answer"] . "(s) ...");
            $tplArt->parse(LNF_TD_CONTENT,".link");

            $light = $light . "<br>\n"; 

            for ($k=0;$k < $depth; $k++) 
                $light = $light . "</blockquote>\n"; 

			if ($index==0)
               $index = 1;
            else
               $index = 0;

            $tplArt->assign(LNF_LINE_BODY,$light); 
            $tplArt->parse(LNF_TD_CONTENT,".line");
            $tplArt->parse(LNF_ROW,"td");
            $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$index);
            $tplArt->parse(LNF_TABLE_ROWS,".row");
			
			$newsnotdisplayed=0;
            $tplArt->assign(LNF_COMMENT_TEXT,"");
            $tplArt->parse(LNF_TD_CONTENT,"comment");
            $tplArt->assign(LNF_LINE_BODY,"");
            $light = "";
         }
        
         $lastBOAN=$lineextract2[0];
	     $levelBOAN=$lineextract2[1]+1;
       
         $numberoftabs=$lineextract2[1];
	     if ($ans=="notset") 
	     {
	       for ($k=0;$k < $numberoftabs; $k++) 
               $light = $light . "<blockquote>\n"; 
	     }
		 else
		   for ($k=$start;$k<$numberoftabs;$k++) 
			   $light = $light . "<blockquote>\n"; 

       }
	   else
         $newsnotdisplayed++;
	   }
       break;

     default:
	   if ($EnableHtml==yes) 
	   {
	      // display HTML tags
		  $ligne=reverse_htmlspecialchars($ligne);
	   }
	   if (($newsnotdisplayed==0) && ($inscope==1)) 
	   {
          $nblignes = $nblignes + 1;

		  // display of the news/answers first line
          if ($nblignes == 1) 
		  {
             // first line of the news : display the image topic 
			 if ($inanswer==0)
			 {
				 $tplArt->assign(LNF_TOPIC_LINK,"listdir".$LNF_file_extension."?top=$topname");
				 $tplArt->assign(LNF_IMAGE_FILE,$url."images/topicimages/".GetTopicImage($topname));
				 $tplArt->assign(LNF_IMAGE_ALIGN,"right");
				 $tplArt->assign(LNF_TOPIC_NAME,$topname);
				 $tplArt->parse(LNF_TD_CONTENT,".image");
			 }
			 $light = $light . "  " . stripslashes($ligne) . "\n"; 
          }
		  else
		     // display of the news/answers lines after the 1st one
             $light = $light . "  <br>". stripslashes($ligne) . "\n"; 
       }
	   break;

   }
   $ligne = fgets($f,16000); 
   if ($exit==1) 
      break;
}



$tplArt->assign(LNF_TABLE_WIDTH,"95%");
$tplArt->parse(FINAL,"table");
$tplArt->FastPrint(FINAL);
fclose($f);
}
?>