<?php
//    LaNewsFactory - web news engine written in PHP
//    Copyright (C) 2000-2002 Christophe Brocas - christophe.brocas@free.fr
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
header("Content-Type: text/plain");

if (file_exists("functions.php"))
   include "functions.php";
else if (file_exists("functions.php3"))
         include "functions.php3";
       else 
       {
         echo "no functions file. Error.";
         exit;
       }

include "lnf-utils-xml".$LNF_file_extension;

// Displays the news without answers in rdf format
//
function DisplayJustRDFArticle($path,$index)
{

global $lang, $display, $colour, $url, $LNF_file_extension ;

// set the maximum number of char of the news to display.
$display_limit=250;

// read in one line all the news file
$fd=fopen("$path","r");
$contents = fread( $fd, 100000);
fclose( $fd );

// check at what position starts/ends the body of the news file
$display_start=strpos($contents, "<body>");
$display_start=$display_start+7;
$display_end=strpos($contents, "</body>");

// checks the number of HTML begin/end link tags (ie "<a " or </a>)are present in the 
//  news extract I want to display
$display_line=substr($contents,$display_start,$display_limit);
$display_deb=sizeof(explode("&lt;a ",$display_line))-1;
$display_fin=sizeof(explode("&lt;/a&gt;",$display_line))-1;

// If the number of HTML begin/end link tags are not equal, I modify the max number 
//  of chars to display the next HTML begin/end link tags
if ($display_deb!=$display_fin)
{
   $display_nextend = strpos($contents, "&lt;/a&gt;", $display_start + $display_limit);
   $display_limit = $display_nextend - $display_start+10;
}

$f=fopen("$path","r");

$nbcar=0;
$nblignes=0;
$index=0;
$lastanswer="";
$lastname="";
$answers=0;
$exit=0;

$index = $index + 1;
echo "\n<item rdf:about=\"". $url . "print".$LNF_file_extension."?art=$path\">\n" ;

$ligne = fgets($f,16000);

while (!feof($f))
{
   //$ligne = ereg_replace("\n", "", $ligne);   
   //$ligne = ereg_replace("<[^>]+>", "", $ligne);
   $tab = explode(">",$ligne);
   switch ($tab[0])
   {
     case "<?xml version='1.0' standalone='yes' ?":
     case "<!-- LNF_message_version='3.1' --":
     case "<news":
     case "<email":
     case "<author":
     case "<date":
   	 case "<reply":
   	 case "</reply":
       break;       
	 
   	 case "<title":
       $lineextract = explode("</",$tab[1]);
       echo "<title>".stripslashes($lineextract[0]) . "</title>\n";
       echo "<link>" . $url . "print".$LNF_file_extension."?art=$path</link>\n";

       if ($index==0)
          $index = 1;
       else
          $index = 0;
       break;

     case "<body":
       echo "<description>\n";
       break;

     case "</body":
       $exit = 1;
       break;

     default:
       $nblignes = $nblignes + 1;

       if (($nbcar + strlen($ligne)) > $display_limit)
       {
          $lig = substr($ligne,0,$display_limit - $nbcar);
          echo "     " . stripslashes($lig) . " ... ";
          $exit = 1;
       }
       elseif ($lignes > 6)
       {
          echo "   ...  ";
          $exit = 1;
       }
       else
       {
          $nbcar  = $nbcar + strlen($ligne);
          $lignes = $lignes + 1;
          if ($lignes == 1)
             echo stripslashes($ligne);
          else
             echo "\n". stripslashes($ligne);
       }
 
       break;

   }

   $ligne = fgets($f,16000); 
   if ($exit == 1)
      break;
}

echo "</description>\n</item>\n\n";

fclose($f);

}

?>
<?php echo "<"."?"; ?>
xml version="1.0" encoding="iso-8859-1"<?php echo "?".">\n"; ?>
<rdf:RDF 
xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
xmlns:dc="http://purl.org/dc/elements/1.1/" 
xmlns:sy="http://purl.org/rss/1.0/modules/syndication/" 
xmlns="http://purl.org/rss/1.0/"
xmlns:admin="http://webns.net/mvcb/"
xmlns:annotate="http://purl.org/rss/1.0/modules/annotate/"
xmlns:dcterms="http://purl.org/dc/terms/"
xmlns:cc="http://web.resource.org/cc/"
xmlns:content="http://purl.org/rss/1.0/modules/content/"
xmlns:foaf="http://xmlns.com/foaf/0.1/"
xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/"
>

<channel rdf:about="<?php echo $url?>">
<title><?php echo $title?></title>
<link><?php echo $url?></link>
<description><?php echo $title?></description>
<?php

// if no particular topic is selected to be exported to RSS format
if (empty($selectedtopic)=="true")
   $selectedtopic="";

$tab = ListDirInArray($selectedtopic . ".<?xml");

$taille = sizeof($tab);

if ($taille > 0) 
{
	rsort($tab);

	$newsperpage = 15;
	if($newsperpage > $taille) $newsperpage = $taille;

  echo "<items>\n";
  echo "<rdf:Seq>\n";
	 for($i=0; $i<$newsperpage; $i++)
    echo "<rdf:li resource=\"".$url . "print".$LNF_file_extension."?art=news/".$tab[$i]."\"/>\n";
  echo "</rdf:Seq>\n";
  echo "</items>\n";
  echo "</channel>\n";
  
	 for($i=0; $i<$newsperpage; $i++)
		 DisplayJustRDFArticle("news/".$tab[$i],$i);
}

?>

</rdf:RDF>

