<?php
//    LaNewsFactory - web news engine written in PHP
//    Copyright (C) 2000-2002 Christophe Brocas - christophe.brocas@free.fr
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

  $tpl = new FastTemplate("templates/$LNF_template"); 
  $tpl->define( array( head      => "lnfhead.tpl", 
                       search    => "search.tpl", 
                       comment   => "comment.tpl",
                       menuitem  => "link.tpl") ); 

  $tpl->assign(LNF_FONT,                $font);
  $tpl->assign(LNF_TITLE,               $title);
  $tpl->assign(LNF_URL,                 $url);
  $tpl->assign(LNF_HOME_DISPLAY,        $display[$lang]["welcomeforum"]);
  $tpl->assign(LNF_ADMIN_DISPLAY,       $display[$lang]["login"]);
  
  if ($way==1)
     $currenttop="news-";
  else
     if ($currenttopic!="AllTopics")
        $currenttop="news/".$currenttopic."-";
     else 
        $currenttop="";
     

  // Check if the user is connected to display the LOGOUT link
  if ($currenttop!="")
     if (($Admin == ReadPassword()) || ($Moderator == ReadPassword($currenttop."modpass".$LNF_file_extension)) || ($Reader == ReadPassword($currenttop."readerpass".$LNF_file_extension)) || ($Poster == ReadPassword($currenttop."posterpass".$LNF_file_extension)))
        $tpl->assign(LNF_LOGOUT_DISPLAY,   "<a href=\"logout".$LNF_file_extension."\">".$display[$lang]["disconnect"]."</a><br>");
     else
        $tpl->assign(LNF_LOGOUT_DISPLAY,   "");
  else
     $tpl->assign(LNF_LOGOUT_DISPLAY,   "");

  // Don't allow to search when you don't have select a current topic in a forums site
  if (($currenttopic!="AllTopics") || ($way==1)) 
  {
     $tpl->assign(LNF_SEARCH_DISPLAY, $display[$lang]["search"]);
     $tpl->parse(LNF_SEARCH, "search"); 
  }
  else
  {
     $tpl->assign(LNF_COMMENT_TEXT, "no search when no topic is selected in a forum site");
     $tpl->parse(LNF_SEARCH, "comment"); 
  }

  // Don't allow to post a news when 
  // . the site allows posting news only from logged users
  // or
  // . you don't have select a current topic in a forums site
  // or
  // . no topic exists in all cases

  $listtop=ListDirInArray(".top", $pathname="news");
  $taillelist=sizeof($listtop);

  $ok_to_display_post_link=1;
  if ($LNF_site_restricted_post==1)
     $ok_to_display_post_link=CheckHabilitation("Poster",$currenttopic,"return");

  if ((($currenttopic!="AllTopics") || (($way==1))) && ($ok_to_display_post_link)) 
  {
	 $tpl->assign(LNF_LINK, "contrib".$LNF_file_extension); 
	 $tpl->assign(LNF_DISPLAY, $display[$lang]["writeanews"]); 
	 $tpl->parse(LNF_CONTRIB, "menuitem"); 
  }
  else
  {
	 $tpl->assign(LNF_COMMENT_TEXT, "no contrib when no topic is selected in a forum site or when no topic exist at all");
	 $tpl->parse(LNF_CONTRIB, "comment"); 
  }

  if (($way==1) && ($currenttopic=="AllTopics"))
      $tab=ListDirInArray(".xml", $pathname="news/mod");
  else
      $tab=ListDirInArray("-$currenttopic.xml", $pathname="news/mod");

  $taille=sizeof($tab);

  // Displays the moderation status for the current topic
  if ($moderate == yes)
  {
     $tpl->assign(LNF_MOD_IMAGE, "mode.png"); 
     $tpl->assign(LNF_MOD_STATUS, $display[$lang]["moderatedsite"]); 
  }
  else
  {
     $tpl->assign(LNF_MOD_IMAGE, "null.png"); 
     $tpl->assign(LNF_MOD_STATUS, $display[$lang]["unmoderatedsite"]); 
  }

  // Displays the number of news up to moderation
  $tpl->assign(LNF_MOD_NUM, $taille); 
   
  if ($way == 0) // Forum attitude
      $currenttop = "news/" . $currenttopic;
  else           // News system attitude
      $currenttop = "news";


  $tpl->assign(LNF_COMMENT_TEXT, "start to display habilitations");
  $tpl->parse(LNF_HABILITATIONS, "comment"); 
  if ($Admin == ReadPassword()) 
  {
	$tpl->assign(LNF_LINK, "createtopic".$LNF_file_extension); 
    $tpl->assign(LNF_DISPLAY, $display[$lang]["topiccreation"]); 
    $tpl->parse(LNF_HABILITATIONS, ".menuitem"); 
	$tpl->assign(LNF_LINK, "deletetopic".$LNF_file_extension); 
    $tpl->assign(LNF_DISPLAY, $display[$lang]["deletetopic"]); 
    $tpl->parse(LNF_HABILITATIONS, ".menuitem"); 
	$tpl->assign(LNF_LINK, "sitesettingsdisp".$LNF_file_extension); 
    $tpl->assign(LNF_DISPLAY, $display[$lang]["siteoptions"]); 
    $tpl->parse(LNF_HABILITATIONS, ".menuitem"); 
    
	if (($currenttopic!="AllTopics") || ($way==1)) 
	{
       $tpl->assign(LNF_LINK, "selecttopic".$LNF_file_extension."?action=settingsdisp"); 
       $tpl->assign(LNF_DISPLAY, $display[$lang]["topicoptions"]); 
       $tpl->parse(LNF_HABILITATIONS, ".menuitem"); 
       $tpl->assign(LNF_LINK, "listmod".$LNF_file_extension); 
       $tpl->assign(LNF_DISPLAY, $display[$lang]["moderation"]); 
       $tpl->parse(LNF_HABILITATIONS, ".menuitem"); 
       $tpl->assign(LNF_LINK, "listnews".$LNF_file_extension); 
       $tpl->assign(LNF_DISPLAY, $display[$lang]["newsmanagement"]); 
       $tpl->parse(LNF_HABILITATIONS, ".menuitem"); 
       $tpl->assign(LNF_LINK, "chpasswd".$LNF_file_extension); 
       $tpl->assign(LNF_DISPLAY, $display[$lang]["changepassword"]); 
       $tpl->parse(LNF_HABILITATIONS, ".menuitem"); 
	}
  }
  else
  {
    if (($currenttopic!="AllTopics")|| ($way==1)) 
    {
       if ($Moderator == ReadPassword("$currenttop-modpass".$LNF_file_extension)) 
	   {
          $tpl->assign(LNF_LINK, "listmod".$LNF_file_extension); 
          $tpl->assign(LNF_DISPLAY, $display[$lang]["moderation"]); 
          $tpl->parse(LNF_HABILITATIONS, ".menuitem"); 
          $tpl->assign(LNF_LINK, "listnews".$LNF_file_extension); 
          $tpl->assign(LNF_DISPLAY, $display[$lang]["newsmanagement"]); 
          $tpl->parse(LNF_HABILITATIONS, ".menuitem"); 
	   }
    }
  }
  // Display topics.  

  $tpl->assign(LNF_COMMENT_TEXT, "start to display topics");
  $tpl->parse(LNF_TOPICS, "comment"); 

  if ($way==1) // News system attitude
  {
     $tpl->assign(LNF_LINK, "listdir".$LNF_file_extension."?top=AllTopics"); 
     if ($currenttopic=="AllTopics")
	     $tpl->assign(LNF_DISPLAY, "<b>" . $display[$lang]["alltopics"] . "</b>");
	 else
	     $tpl->assign(LNF_DISPLAY, $display[$lang]["alltopics"]);
     $tpl->parse(LNF_TOPICS, ".menuitem"); 
  }
 
  $tab=ListDirInArray(".top", "news");
  $taille=sizeof($tab);

  for ($ind=0; $ind < $taille; $ind++) 
  {   
      $tab2 = explode(".top",$tab[$ind]);
  
	  $tpl->assign(LNF_LINK, "listdir".$LNF_file_extension."?top=". $tab2[0]); 
      if ($currenttopic==$tab2[0])
         $tpl->assign(LNF_DISPLAY, "<b>" . $tab2[0] . "</b>");
      else
         $tpl->assign(LNF_DISPLAY, $tab2[0]);
      
	  $tpl->parse(LNF_TOPICS, ".menuitem"); 
  }

  if ( (!isset($lnferror)) || (empty($lnferror)) )
	  $tpl->assign(LNF_ERROR, "");
  else   
	  $tpl->assign(LNF_ERROR, "<b>".$display[$lang]["error"] ." : </b>". $lnferror . "<P>");

  $tpl->parse(FINAL, "head"); 
  $tpl->FastPrint(FINAL); 
?>